/* User.c generated by valac 0.25.1, the Vala compiler
 * generated from User.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2013-2014 Birdie Developers (http://birdieapp.github.io)
 *
 * This software is licensed under the GNU General Public License
 * (version 3 or later). See the COPYING file in this distribution.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * Authored by: Ivo Nunes <ivoavnunes@gmail.com>
 *              Vasco Nunes <vascomfnunes@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gobject/gvaluecollector.h>


#define BIRDIE_TYPE_USER (birdie_user_get_type ())
#define BIRDIE_USER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BIRDIE_TYPE_USER, BirdieUser))
#define BIRDIE_USER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BIRDIE_TYPE_USER, BirdieUserClass))
#define BIRDIE_IS_USER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BIRDIE_TYPE_USER))
#define BIRDIE_IS_USER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BIRDIE_TYPE_USER))
#define BIRDIE_USER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BIRDIE_TYPE_USER, BirdieUserClass))

typedef struct _BirdieUser BirdieUser;
typedef struct _BirdieUserClass BirdieUserClass;
typedef struct _BirdieUserPrivate BirdieUserPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _BirdieParamSpecUser BirdieParamSpecUser;

struct _BirdieUser {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BirdieUserPrivate * priv;
	gchar* id;
	gchar* name;
	gchar* screen_name;
	gchar* profile_image_url;
	gchar* profile_image_file;
	gchar* location;
	gchar* website;
	gchar* desc;
	gint64 friends_count;
	gint64 followers_count;
	gint64 statuses_count;
	gboolean verified;
	gchar* token;
	gchar* token_secret;
	gchar* service;
};

struct _BirdieUserClass {
	GTypeClass parent_class;
	void (*finalize) (BirdieUser *self);
};

struct _BirdieParamSpecUser {
	GParamSpec parent_instance;
};


static gpointer birdie_user_parent_class = NULL;

gpointer birdie_user_ref (gpointer instance);
void birdie_user_unref (gpointer instance);
GParamSpec* birdie_param_spec_user (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void birdie_value_set_user (GValue* value, gpointer v_object);
void birdie_value_take_user (GValue* value, gpointer v_object);
gpointer birdie_value_get_user (const GValue* value);
GType birdie_user_get_type (void) G_GNUC_CONST;
enum  {
	BIRDIE_USER_DUMMY_PROPERTY
};
BirdieUser* birdie_user_new (const gchar* id, const gchar* name, const gchar* screen_name, const gchar* profile_image_url, const gchar* profile_image_file, const gchar* location, const gchar* website, const gchar* desc, gint64 friends_count, gint64 followers_count, gint64 statuses_count, gboolean verified, const gchar* token, const gchar* token_secret, const gchar* service);
BirdieUser* birdie_user_construct (GType object_type, const gchar* id, const gchar* name, const gchar* screen_name, const gchar* profile_image_url, const gchar* profile_image_file, const gchar* location, const gchar* website, const gchar* desc, gint64 friends_count, gint64 followers_count, gint64 statuses_count, gboolean verified, const gchar* token, const gchar* token_secret, const gchar* service);
gchar* birdie_utils_highlight_all (gchar* text);
static void birdie_user_finalize (BirdieUser* obj);


static gchar* string_chomp (const gchar* self) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	g_strchomp (_tmp1_);
	result = _result_;
	return result;
}


BirdieUser* birdie_user_construct (GType object_type, const gchar* id, const gchar* name, const gchar* screen_name, const gchar* profile_image_url, const gchar* profile_image_file, const gchar* location, const gchar* website, const gchar* desc, gint64 friends_count, gint64 followers_count, gint64 statuses_count, gboolean verified, const gchar* token, const gchar* token_secret, const gchar* service) {
	BirdieUser* self = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	const gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	const gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	const gchar* _tmp11_ = NULL;
	gchar* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	const gchar* _tmp14_ = NULL;
	gchar* _tmp15_ = NULL;
	const gchar* _tmp16_ = NULL;
	gchar* _tmp17_ = NULL;
	gchar* _tmp18_ = NULL;
	gint64 _tmp19_ = 0LL;
	gint64 _tmp20_ = 0LL;
	gint64 _tmp21_ = 0LL;
	gboolean _tmp22_ = FALSE;
	const gchar* _tmp23_ = NULL;
	gchar* _tmp24_ = NULL;
	const gchar* _tmp25_ = NULL;
	gchar* _tmp26_ = NULL;
	const gchar* _tmp27_ = NULL;
	gchar* _tmp28_ = NULL;
	g_return_val_if_fail (id != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	g_return_val_if_fail (screen_name != NULL, NULL);
	g_return_val_if_fail (profile_image_url != NULL, NULL);
	g_return_val_if_fail (profile_image_file != NULL, NULL);
	g_return_val_if_fail (location != NULL, NULL);
	g_return_val_if_fail (website != NULL, NULL);
	g_return_val_if_fail (desc != NULL, NULL);
	g_return_val_if_fail (token != NULL, NULL);
	g_return_val_if_fail (token_secret != NULL, NULL);
	g_return_val_if_fail (service != NULL, NULL);
	self = (BirdieUser*) g_type_create_instance (object_type);
	_tmp0_ = id;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->id);
	self->id = _tmp1_;
	_tmp2_ = name;
	_tmp3_ = string_chomp (_tmp2_);
	_tmp4_ = birdie_utils_highlight_all (_tmp3_);
	_g_free0 (self->name);
	self->name = _tmp4_;
	_tmp5_ = screen_name;
	_tmp6_ = g_strdup (_tmp5_);
	_g_free0 (self->screen_name);
	self->screen_name = _tmp6_;
	_tmp7_ = profile_image_url;
	_tmp8_ = g_strdup (_tmp7_);
	_g_free0 (self->profile_image_url);
	self->profile_image_url = _tmp8_;
	_tmp9_ = profile_image_file;
	_tmp10_ = g_strdup (_tmp9_);
	_g_free0 (self->profile_image_file);
	self->profile_image_file = _tmp10_;
	_tmp11_ = location;
	_tmp12_ = g_strdup (_tmp11_);
	_tmp13_ = birdie_utils_highlight_all (_tmp12_);
	_g_free0 (self->location);
	self->location = _tmp13_;
	_tmp14_ = website;
	_tmp15_ = g_strdup (_tmp14_);
	_g_free0 (self->website);
	self->website = _tmp15_;
	_tmp16_ = desc;
	_tmp17_ = g_strdup (_tmp16_);
	_tmp18_ = birdie_utils_highlight_all (_tmp17_);
	_g_free0 (self->desc);
	self->desc = _tmp18_;
	_tmp19_ = friends_count;
	self->friends_count = _tmp19_;
	_tmp20_ = followers_count;
	self->followers_count = _tmp20_;
	_tmp21_ = statuses_count;
	self->statuses_count = _tmp21_;
	_tmp22_ = verified;
	self->verified = _tmp22_;
	_tmp23_ = token;
	_tmp24_ = g_strdup (_tmp23_);
	_g_free0 (self->token);
	self->token = _tmp24_;
	_tmp25_ = token_secret;
	_tmp26_ = g_strdup (_tmp25_);
	_g_free0 (self->token_secret);
	self->token_secret = _tmp26_;
	_tmp27_ = service;
	_tmp28_ = g_strdup (_tmp27_);
	_g_free0 (self->service);
	self->service = _tmp28_;
	return self;
}


BirdieUser* birdie_user_new (const gchar* id, const gchar* name, const gchar* screen_name, const gchar* profile_image_url, const gchar* profile_image_file, const gchar* location, const gchar* website, const gchar* desc, gint64 friends_count, gint64 followers_count, gint64 statuses_count, gboolean verified, const gchar* token, const gchar* token_secret, const gchar* service) {
	return birdie_user_construct (BIRDIE_TYPE_USER, id, name, screen_name, profile_image_url, profile_image_file, location, website, desc, friends_count, followers_count, statuses_count, verified, token, token_secret, service);
}


static void birdie_value_user_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void birdie_value_user_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		birdie_user_unref (value->data[0].v_pointer);
	}
}


static void birdie_value_user_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = birdie_user_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer birdie_value_user_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* birdie_value_user_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		BirdieUser* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = birdie_user_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* birdie_value_user_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	BirdieUser** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = birdie_user_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* birdie_param_spec_user (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	BirdieParamSpecUser* spec;
	g_return_val_if_fail (g_type_is_a (object_type, BIRDIE_TYPE_USER), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer birdie_value_get_user (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, BIRDIE_TYPE_USER), NULL);
	return value->data[0].v_pointer;
}


void birdie_value_set_user (GValue* value, gpointer v_object) {
	BirdieUser* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, BIRDIE_TYPE_USER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, BIRDIE_TYPE_USER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		birdie_user_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		birdie_user_unref (old);
	}
}


void birdie_value_take_user (GValue* value, gpointer v_object) {
	BirdieUser* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, BIRDIE_TYPE_USER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, BIRDIE_TYPE_USER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		birdie_user_unref (old);
	}
}


static void birdie_user_class_init (BirdieUserClass * klass) {
	birdie_user_parent_class = g_type_class_peek_parent (klass);
	((BirdieUserClass *) klass)->finalize = birdie_user_finalize;
}


static void birdie_user_instance_init (BirdieUser * self) {
	self->ref_count = 1;
}


static void birdie_user_finalize (BirdieUser* obj) {
	BirdieUser * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BIRDIE_TYPE_USER, BirdieUser);
	g_signal_handlers_destroy (self);
	_g_free0 (self->id);
	_g_free0 (self->name);
	_g_free0 (self->screen_name);
	_g_free0 (self->profile_image_url);
	_g_free0 (self->profile_image_file);
	_g_free0 (self->location);
	_g_free0 (self->website);
	_g_free0 (self->desc);
	_g_free0 (self->token);
	_g_free0 (self->token_secret);
	_g_free0 (self->service);
}


GType birdie_user_get_type (void) {
	static volatile gsize birdie_user_type_id__volatile = 0;
	if (g_once_init_enter (&birdie_user_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { birdie_value_user_init, birdie_value_user_free_value, birdie_value_user_copy_value, birdie_value_user_peek_pointer, "p", birdie_value_user_collect_value, "p", birdie_value_user_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (BirdieUserClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) birdie_user_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BirdieUser), 0, (GInstanceInitFunc) birdie_user_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType birdie_user_type_id;
		birdie_user_type_id = g_type_register_fundamental (g_type_fundamental_next (), "BirdieUser", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&birdie_user_type_id__volatile, birdie_user_type_id);
	}
	return birdie_user_type_id__volatile;
}


gpointer birdie_user_ref (gpointer instance) {
	BirdieUser* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void birdie_user_unref (gpointer instance) {
	BirdieUser* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		BIRDIE_USER_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}



