/* Notifications.c generated by valac 0.25.1, the Vala compiler
 * generated from Notifications.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2013-2014 Birdie Developers (http://birdieapp.github.io)
 *
 * This software is licensed under the GNU General Public License
 * (version 3 or later). See the COPYING file in this distribution.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * Authored by: Ivo Nunes <ivoavnunes@gmail.com>
 *              Vasco Nunes <vascomfnunes@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <libnotify/notify.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <canberra.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <gobject/gvaluecollector.h>


#define BIRDIE_UTILS_TYPE_NOTIFICATION (birdie_utils_notification_get_type ())
#define BIRDIE_UTILS_NOTIFICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BIRDIE_UTILS_TYPE_NOTIFICATION, BirdieUtilsNotification))
#define BIRDIE_UTILS_NOTIFICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BIRDIE_UTILS_TYPE_NOTIFICATION, BirdieUtilsNotificationClass))
#define BIRDIE_UTILS_IS_NOTIFICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BIRDIE_UTILS_TYPE_NOTIFICATION))
#define BIRDIE_UTILS_IS_NOTIFICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BIRDIE_UTILS_TYPE_NOTIFICATION))
#define BIRDIE_UTILS_NOTIFICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BIRDIE_UTILS_TYPE_NOTIFICATION, BirdieUtilsNotificationClass))

typedef struct _BirdieUtilsNotification BirdieUtilsNotification;
typedef struct _BirdieUtilsNotificationClass BirdieUtilsNotificationClass;
typedef struct _BirdieUtilsNotificationPrivate BirdieUtilsNotificationPrivate;

#define BIRDIE_TYPE_BIRDIE (birdie_birdie_get_type ())
#define BIRDIE_BIRDIE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BIRDIE_TYPE_BIRDIE, BirdieBirdie))
#define BIRDIE_BIRDIE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BIRDIE_TYPE_BIRDIE, BirdieBirdieClass))
#define BIRDIE_IS_BIRDIE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BIRDIE_TYPE_BIRDIE))
#define BIRDIE_IS_BIRDIE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BIRDIE_TYPE_BIRDIE))
#define BIRDIE_BIRDIE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BIRDIE_TYPE_BIRDIE, BirdieBirdieClass))

typedef struct _BirdieBirdie BirdieBirdie;
typedef struct _BirdieBirdieClass BirdieBirdieClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __g_list_free__g_free0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_free0_ (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block52Data Block52Data;
#define _birdie_utils_notification_unref0(var) ((var == NULL) ? NULL : (var = (birdie_utils_notification_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _ca_context_destroy0(var) ((var == NULL) ? NULL : (var = (ca_context_destroy (var), NULL)))
typedef struct _BirdieUtilsParamSpecNotification BirdieUtilsParamSpecNotification;

struct _BirdieUtilsNotification {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BirdieUtilsNotificationPrivate * priv;
};

struct _BirdieUtilsNotificationClass {
	GTypeClass parent_class;
	void (*finalize) (BirdieUtilsNotification *self);
};

struct _BirdieUtilsNotificationPrivate {
	NotifyNotification* notification;
	BirdieBirdie* birdie_app;
	GList* caps;
};

struct _Block52Data {
	int _ref_count_;
	BirdieUtilsNotification* self;
	gchar* timeline;
};

struct _BirdieUtilsParamSpecNotification {
	GParamSpec parent_instance;
};


static gpointer birdie_utils_notification_parent_class = NULL;
static ca_context* birdie_utils_notification_sound_context;
static ca_context* birdie_utils_notification_sound_context = NULL;

gpointer birdie_utils_notification_ref (gpointer instance);
void birdie_utils_notification_unref (gpointer instance);
GParamSpec* birdie_utils_param_spec_notification (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void birdie_utils_value_set_notification (GValue* value, gpointer v_object);
void birdie_utils_value_take_notification (GValue* value, gpointer v_object);
gpointer birdie_utils_value_get_notification (const GValue* value);
GType birdie_utils_notification_get_type (void) G_GNUC_CONST;
GType birdie_birdie_get_type (void) G_GNUC_CONST;
#define BIRDIE_UTILS_NOTIFICATION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), BIRDIE_UTILS_TYPE_NOTIFICATION, BirdieUtilsNotificationPrivate))
enum  {
	BIRDIE_UTILS_NOTIFICATION_DUMMY_PROPERTY
};
static void _g_free0_ (gpointer var);
static void _g_list_free__g_free0_ (GList* self);
void birdie_utils_notification_init (BirdieUtilsNotification* self);
static void birdie_utils_notification_init_sound (void);
void birdie_utils_notification_notify (BirdieUtilsNotification* self, BirdieBirdie* birdie, const gchar* header, const gchar* message, const gchar* timeline, gboolean* dm, const gchar* avatar);
static Block52Data* block52_data_ref (Block52Data* _data52_);
static void block52_data_unref (void * _userdata_);
gchar* birdie_utils_remove_html_tags (const gchar* input);
gchar* birdie_utils_escape_markup (gchar* text);
static void __lambda111_ (Block52Data* _data52_, NotifyNotification* notification, const gchar* action);
void birdie_birdie_switch_timeline (BirdieBirdie* self, const gchar* new_timeline);
static void ___lambda111__notify_action_callback (NotifyNotification* notification, const gchar* action, gpointer self);
void birdie_utils_notification_play_sound (const gchar* sound);
void birdie_utils_notification_uninit (BirdieUtilsNotification* self);
BirdieUtilsNotification* birdie_utils_notification_new (void);
BirdieUtilsNotification* birdie_utils_notification_construct (GType object_type);
static void birdie_utils_notification_finalize (BirdieUtilsNotification* obj);


static void _g_free0_ (gpointer var) {
	var = (g_free (var), NULL);
}


static void _g_list_free__g_free0_ (GList* self) {
	g_list_foreach (self, (GFunc) _g_free0_, NULL);
	g_list_free (self);
}


void birdie_utils_notification_init (BirdieUtilsNotification* self) {
	GList* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	notify_init ("Birdie");
	birdie_utils_notification_init_sound ();
	_tmp0_ = notify_get_server_caps ();
	__g_list_free__g_free0_0 (self->priv->caps);
	self->priv->caps = _tmp0_;
}


static Block52Data* block52_data_ref (Block52Data* _data52_) {
	g_atomic_int_inc (&_data52_->_ref_count_);
	return _data52_;
}


static void block52_data_unref (void * _userdata_) {
	Block52Data* _data52_;
	_data52_ = (Block52Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data52_->_ref_count_)) {
		BirdieUtilsNotification* self;
		self = _data52_->self;
		_g_free0 (_data52_->timeline);
		_birdie_utils_notification_unref0 (self);
		g_slice_free (Block52Data, _data52_);
	}
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void __lambda111_ (Block52Data* _data52_, NotifyNotification* notification, const gchar* action) {
	BirdieUtilsNotification* self;
	BirdieBirdie* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	BirdieBirdie* _tmp2_ = NULL;
	self = _data52_->self;
	g_return_if_fail (notification != NULL);
	g_return_if_fail (action != NULL);
	_tmp0_ = self->priv->birdie_app;
	_tmp1_ = _data52_->timeline;
	birdie_birdie_switch_timeline (_tmp0_, _tmp1_);
	_tmp2_ = self->priv->birdie_app;
	g_application_activate ((GApplication*) _tmp2_);
}


static void ___lambda111__notify_action_callback (NotifyNotification* notification, const gchar* action, gpointer self) {
	__lambda111_ (self, notification, action);
}


void birdie_utils_notification_notify (BirdieUtilsNotification* self, BirdieBirdie* birdie, const gchar* header, const gchar* message, const gchar* timeline, gboolean* dm, const gchar* avatar) {
	Block52Data* _data52_;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	BirdieBirdie* _tmp2_ = NULL;
	BirdieBirdie* _tmp3_ = NULL;
	gchar* notification_txt = NULL;
	gchar* avatar_path = NULL;
	const gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	gboolean _tmp9_ = FALSE;
	const gchar* _tmp10_ = NULL;
	const gchar* _tmp20_ = NULL;
	const gchar* _tmp21_ = NULL;
	const gchar* _tmp22_ = NULL;
	NotifyNotification* _tmp23_ = NULL;
	NotifyNotification* _tmp24_ = NULL;
	NotifyNotification* _tmp25_ = NULL;
	gboolean* _tmp26_ = NULL;
	NotifyNotification* _tmp29_ = NULL;
	const gchar* _tmp30_ = NULL;
	GList* _tmp34_ = NULL;
	GList* _tmp35_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (birdie != NULL);
	g_return_if_fail (header != NULL);
	_data52_ = g_slice_new0 (Block52Data);
	_data52_->_ref_count_ = 1;
	_data52_->self = birdie_utils_notification_ref (self);
	_tmp0_ = timeline;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (_data52_->timeline);
	_data52_->timeline = _tmp1_;
	_tmp2_ = birdie;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	_g_object_unref0 (self->priv->birdie_app);
	self->priv->birdie_app = _tmp3_;
	_tmp4_ = message;
	_tmp5_ = birdie_utils_remove_html_tags (_tmp4_);
	_g_free0 (notification_txt);
	notification_txt = _tmp5_;
	_tmp6_ = notification_txt;
	_tmp7_ = g_strdup (_tmp6_);
	_tmp8_ = birdie_utils_escape_markup (_tmp7_);
	_g_free0 (notification_txt);
	notification_txt = _tmp8_;
	_tmp10_ = avatar;
	if (g_strcmp0 (_tmp10_, "") != 0) {
		const gchar* _tmp11_ = NULL;
		_tmp11_ = avatar;
		_tmp9_ = _tmp11_ != NULL;
	} else {
		_tmp9_ = FALSE;
	}
	if (_tmp9_) {
		GFile* file = NULL;
		const gchar* _tmp12_ = NULL;
		GFile* _tmp13_ = NULL;
		GFile* _tmp14_ = NULL;
		gboolean _tmp15_ = FALSE;
		_tmp12_ = avatar;
		_tmp13_ = g_file_new_for_path (_tmp12_);
		file = _tmp13_;
		_tmp14_ = file;
		_tmp15_ = g_file_query_exists (_tmp14_, NULL);
		if (_tmp15_) {
			const gchar* _tmp16_ = NULL;
			gchar* _tmp17_ = NULL;
			_tmp16_ = avatar;
			_tmp17_ = g_strdup (_tmp16_);
			_g_free0 (avatar_path);
			avatar_path = _tmp17_;
		} else {
			gchar* _tmp18_ = NULL;
			_tmp18_ = g_strdup ("birdie");
			_g_free0 (avatar_path);
			avatar_path = _tmp18_;
		}
		_g_object_unref0 (file);
	} else {
		gchar* _tmp19_ = NULL;
		_tmp19_ = g_strdup ("birdie");
		_g_free0 (avatar_path);
		avatar_path = _tmp19_;
	}
	_tmp20_ = header;
	_tmp21_ = notification_txt;
	_tmp22_ = avatar_path;
	_tmp23_ = notify_notification_new (_tmp20_, _tmp21_, _tmp22_);
	_g_object_unref0 (self->priv->notification);
	self->priv->notification = _tmp23_;
	_tmp24_ = self->priv->notification;
	notify_notification_set_hint_string (_tmp24_, "desktop-entry", "birdie");
	_tmp25_ = self->priv->notification;
	notify_notification_set_urgency (_tmp25_, NOTIFY_URGENCY_NORMAL);
	_tmp26_ = dm;
	if (*_tmp26_) {
		NotifyNotification* _tmp27_ = NULL;
		NotifyNotification* _tmp28_ = NULL;
		_tmp27_ = self->priv->notification;
		notify_notification_set_timeout (_tmp27_, 0);
		_tmp28_ = self->priv->notification;
		notify_notification_set_urgency (_tmp28_, NOTIFY_URGENCY_CRITICAL);
	}
	_tmp29_ = self->priv->notification;
	_tmp30_ = _ ("View");
	notify_notification_add_action (_tmp29_, "view", _tmp30_, ___lambda111__notify_action_callback, block52_data_ref (_data52_), block52_data_unref);
	{
		NotifyNotification* _tmp31_ = NULL;
		_tmp31_ = self->priv->notification;
		notify_notification_show (_tmp31_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch86_g_error;
		}
	}
	goto __finally86;
	__catch86_g_error:
	{
		GError* e = NULL;
		GError* _tmp32_ = NULL;
		const gchar* _tmp33_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp32_ = e;
		_tmp33_ = _tmp32_->message;
		g_warning ("Notifications.vala:75: Failed to show notification: %s", _tmp33_);
		_g_error_free0 (e);
	}
	__finally86:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_free0 (avatar_path);
		_g_free0 (notification_txt);
		block52_data_unref (_data52_);
		_data52_ = NULL;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_tmp34_ = self->priv->caps;
	_tmp35_ = g_list_find (_tmp34_, "message");
	if (_tmp35_ != NULL) {
		NotifyNotification* _tmp36_ = NULL;
		_tmp36_ = self->priv->notification;
		notify_notification_set_hint_string (_tmp36_, "sound-name", "message");
	} else {
		birdie_utils_notification_play_sound ("message");
	}
	_g_free0 (avatar_path);
	_g_free0 (notification_txt);
	block52_data_unref (_data52_);
	_data52_ = NULL;
}


static void birdie_utils_notification_init_sound (void) {
	ca_context* _tmp0_ = NULL;
	_tmp0_ = birdie_utils_notification_sound_context;
	if (_tmp0_ == NULL) {
		ca_context* _tmp1_ = NULL;
		ca_context_create (&_tmp1_);
		_ca_context_destroy0 (birdie_utils_notification_sound_context);
		birdie_utils_notification_sound_context = _tmp1_;
	}
}


void birdie_utils_notification_play_sound (const gchar* sound) {
	ca_context* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	g_return_if_fail (sound != NULL);
	birdie_utils_notification_init_sound ();
	_tmp0_ = birdie_utils_notification_sound_context;
	_tmp1_ = sound;
	ca_context_play (_tmp0_, (guint32) 0, CA_PROP_EVENT_ID, _tmp1_, NULL);
}


void birdie_utils_notification_uninit (BirdieUtilsNotification* self) {
	g_return_if_fail (self != NULL);
	notify_uninit ();
}


BirdieUtilsNotification* birdie_utils_notification_construct (GType object_type) {
	BirdieUtilsNotification* self = NULL;
	self = (BirdieUtilsNotification*) g_type_create_instance (object_type);
	return self;
}


BirdieUtilsNotification* birdie_utils_notification_new (void) {
	return birdie_utils_notification_construct (BIRDIE_UTILS_TYPE_NOTIFICATION);
}


static void birdie_utils_value_notification_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void birdie_utils_value_notification_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		birdie_utils_notification_unref (value->data[0].v_pointer);
	}
}


static void birdie_utils_value_notification_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = birdie_utils_notification_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer birdie_utils_value_notification_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* birdie_utils_value_notification_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		BirdieUtilsNotification* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = birdie_utils_notification_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* birdie_utils_value_notification_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	BirdieUtilsNotification** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = birdie_utils_notification_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* birdie_utils_param_spec_notification (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	BirdieUtilsParamSpecNotification* spec;
	g_return_val_if_fail (g_type_is_a (object_type, BIRDIE_UTILS_TYPE_NOTIFICATION), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer birdie_utils_value_get_notification (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, BIRDIE_UTILS_TYPE_NOTIFICATION), NULL);
	return value->data[0].v_pointer;
}


void birdie_utils_value_set_notification (GValue* value, gpointer v_object) {
	BirdieUtilsNotification* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, BIRDIE_UTILS_TYPE_NOTIFICATION));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, BIRDIE_UTILS_TYPE_NOTIFICATION));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		birdie_utils_notification_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		birdie_utils_notification_unref (old);
	}
}


void birdie_utils_value_take_notification (GValue* value, gpointer v_object) {
	BirdieUtilsNotification* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, BIRDIE_UTILS_TYPE_NOTIFICATION));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, BIRDIE_UTILS_TYPE_NOTIFICATION));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		birdie_utils_notification_unref (old);
	}
}


static void birdie_utils_notification_class_init (BirdieUtilsNotificationClass * klass) {
	birdie_utils_notification_parent_class = g_type_class_peek_parent (klass);
	((BirdieUtilsNotificationClass *) klass)->finalize = birdie_utils_notification_finalize;
	g_type_class_add_private (klass, sizeof (BirdieUtilsNotificationPrivate));
}


static void birdie_utils_notification_instance_init (BirdieUtilsNotification * self) {
	self->priv = BIRDIE_UTILS_NOTIFICATION_GET_PRIVATE (self);
	self->ref_count = 1;
}


static void birdie_utils_notification_finalize (BirdieUtilsNotification* obj) {
	BirdieUtilsNotification * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BIRDIE_UTILS_TYPE_NOTIFICATION, BirdieUtilsNotification);
	g_signal_handlers_destroy (self);
	_g_object_unref0 (self->priv->notification);
	_g_object_unref0 (self->priv->birdie_app);
	__g_list_free__g_free0_0 (self->priv->caps);
}


GType birdie_utils_notification_get_type (void) {
	static volatile gsize birdie_utils_notification_type_id__volatile = 0;
	if (g_once_init_enter (&birdie_utils_notification_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { birdie_utils_value_notification_init, birdie_utils_value_notification_free_value, birdie_utils_value_notification_copy_value, birdie_utils_value_notification_peek_pointer, "p", birdie_utils_value_notification_collect_value, "p", birdie_utils_value_notification_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (BirdieUtilsNotificationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) birdie_utils_notification_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BirdieUtilsNotification), 0, (GInstanceInitFunc) birdie_utils_notification_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType birdie_utils_notification_type_id;
		birdie_utils_notification_type_id = g_type_register_fundamental (g_type_fundamental_next (), "BirdieUtilsNotification", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&birdie_utils_notification_type_id__volatile, birdie_utils_notification_type_id);
	}
	return birdie_utils_notification_type_id__volatile;
}


gpointer birdie_utils_notification_ref (gpointer instance) {
	BirdieUtilsNotification* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void birdie_utils_notification_unref (gpointer instance) {
	BirdieUtilsNotification* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		BIRDIE_UTILS_NOTIFICATION_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}



