/* Strings.c generated by valac 0.25.1, the Vala compiler
 * generated from Strings.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2013-2014 Birdie Developers (http://birdieapp.github.io)
 *
 * This software is licensed under the GNU General Public License
 * (version 3 or later). See the COPYING file in this distribution.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * Authored by: Ivo Nunes <ivoavnunes@gmail.com>
 *              Vasco Nunes <vascomfnunes@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <purple.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))



gchar* birdie_utils_highlight_all (gchar* text);
gchar* birdie_utils_unescape_html (gchar* text);
gchar* birdie_utils_escape_markup (gchar* text);
gchar* birdie_utils_highlight_urls (gchar* text);
gchar* birdie_utils_highlight_hashtags (gchar* text);
gchar* birdie_utils_highlight_users (gchar* text);
gchar** birdie_utils_get_hashtags_list (const gchar* text, int* result_length1);
gchar* birdie_utils_remove_html_tags (const gchar* input);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


gchar* birdie_utils_highlight_all (gchar* text) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	const gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	gchar* _tmp11_ = NULL;
	const gchar* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	const gchar* _tmp15_ = NULL;
	gchar* _tmp16_ = NULL;
	g_return_val_if_fail (text != NULL, NULL);
	_tmp0_ = text;
	_tmp1_ = g_strdup (_tmp0_);
	_tmp2_ = birdie_utils_unescape_html (_tmp1_);
	_g_free0 (text);
	text = _tmp2_;
	_tmp3_ = text;
	_tmp4_ = g_strdup (_tmp3_);
	_tmp5_ = birdie_utils_escape_markup (_tmp4_);
	_g_free0 (text);
	text = _tmp5_;
	_tmp6_ = text;
	_tmp7_ = g_strdup (_tmp6_);
	_tmp8_ = birdie_utils_highlight_urls (_tmp7_);
	_g_free0 (text);
	text = _tmp8_;
	_tmp9_ = text;
	_tmp10_ = g_strdup (_tmp9_);
	_tmp11_ = birdie_utils_highlight_hashtags (_tmp10_);
	_g_free0 (text);
	text = _tmp11_;
	_tmp12_ = text;
	_tmp13_ = g_strdup (_tmp12_);
	_tmp14_ = birdie_utils_highlight_users (_tmp13_);
	_g_free0 (text);
	text = _tmp14_;
	_tmp15_ = text;
	_tmp16_ = g_strdup (_tmp15_);
	result = _tmp16_;
	_g_free0 (text);
	return result;
}


gchar* birdie_utils_highlight_hashtags (gchar* text) {
	gchar* result = NULL;
	GRegex* hashtags = NULL;
	const gchar* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (text != NULL, NULL);
	{
		gchar* _tmp6_ = NULL;
		GRegex* _tmp7_ = NULL;
		const gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		gchar* _tmp10_ = NULL;
		{
			GRegex* _tmp0_ = NULL;
			GRegex* _tmp1_ = NULL;
			GRegex* _tmp2_ = NULL;
			_tmp1_ = g_regex_new ("\\B([#][[:alpha:]0-9_.-\\p{Latin}\\p{Greek}]+)", 0, 0, &_inner_error_);
			_tmp0_ = _tmp1_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				if (_inner_error_->domain == G_REGEX_ERROR) {
					goto __catch93_g_regex_error;
				}
				_g_regex_unref0 (hashtags);
				_g_free0 (text);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
			_tmp2_ = _tmp0_;
			_tmp0_ = NULL;
			_g_regex_unref0 (hashtags);
			hashtags = _tmp2_;
			_g_regex_unref0 (_tmp0_);
		}
		goto __finally93;
		__catch93_g_regex_error:
		{
			GError* e = NULL;
			GRegex* _tmp3_ = NULL;
			GRegex* _tmp4_ = NULL;
			GRegex* _tmp5_ = NULL;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp4_ = g_regex_new ("\\B([#][[:alpha:]0-9_]+)", 0, 0, &_inner_error_);
			_tmp3_ = _tmp4_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				_g_error_free0 (e);
				goto __finally93;
			}
			_tmp5_ = _tmp3_;
			_tmp3_ = NULL;
			_g_regex_unref0 (hashtags);
			hashtags = _tmp5_;
			_g_regex_unref0 (_tmp3_);
			_g_error_free0 (e);
		}
		__finally93:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch92_g_regex_error;
			}
			_g_regex_unref0 (hashtags);
			_g_free0 (text);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp7_ = hashtags;
		_tmp8_ = text;
		_tmp9_ = g_regex_replace (_tmp7_, _tmp8_, (gssize) (-1), 0, "<span underline='none'><a href='birdie://search/\\0'>\\0</a></span>", 0, &_inner_error_);
		_tmp6_ = _tmp9_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch92_g_regex_error;
			}
			_g_regex_unref0 (hashtags);
			_g_free0 (text);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp10_ = _tmp6_;
		_tmp6_ = NULL;
		_g_free0 (text);
		text = _tmp10_;
		_g_free0 (_tmp6_);
	}
	goto __finally92;
	__catch92_g_regex_error:
	{
		GError* e = NULL;
		GError* _tmp11_ = NULL;
		const gchar* _tmp12_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp11_ = e;
		_tmp12_ = _tmp11_->message;
		g_warning ("Strings.vala:41: regex error: %s", _tmp12_);
		_g_error_free0 (e);
	}
	__finally92:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_regex_unref0 (hashtags);
		_g_free0 (text);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp13_ = text;
	_tmp14_ = g_strdup (_tmp13_);
	result = _tmp14_;
	_g_regex_unref0 (hashtags);
	_g_free0 (text);
	return result;
}


gchar** birdie_utils_get_hashtags_list (const gchar* text, int* result_length1) {
	gchar** result = NULL;
	GRegex* hashtags = NULL;
	GRegex* _tmp8_ = NULL;
	const gchar* _tmp9_ = NULL;
	gchar** _tmp10_ = NULL;
	gchar** _tmp11_ = NULL;
	gchar** _tmp12_ = NULL;
	gint _tmp12__length1 = 0;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (text != NULL, NULL);
	hashtags = NULL;
	{
		{
			GRegex* _tmp0_ = NULL;
			GRegex* _tmp1_ = NULL;
			GRegex* _tmp2_ = NULL;
			_tmp1_ = g_regex_new ("\\B([#][[:alpha:]0-9_.-\\p{Latin}\\p{Greek}]+)", 0, 0, &_inner_error_);
			_tmp0_ = _tmp1_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				if (_inner_error_->domain == G_REGEX_ERROR) {
					goto __catch95_g_regex_error;
				}
				_g_regex_unref0 (hashtags);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
			_tmp2_ = _tmp0_;
			_tmp0_ = NULL;
			_g_regex_unref0 (hashtags);
			hashtags = _tmp2_;
			_g_regex_unref0 (_tmp0_);
		}
		goto __finally95;
		__catch95_g_regex_error:
		{
			GError* e = NULL;
			GRegex* _tmp3_ = NULL;
			GRegex* _tmp4_ = NULL;
			GRegex* _tmp5_ = NULL;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp4_ = g_regex_new ("\\B([#][[:alpha:]0-9_]+)", 0, 0, &_inner_error_);
			_tmp3_ = _tmp4_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				_g_error_free0 (e);
				goto __finally95;
			}
			_tmp5_ = _tmp3_;
			_tmp3_ = NULL;
			_g_regex_unref0 (hashtags);
			hashtags = _tmp5_;
			_g_regex_unref0 (_tmp3_);
			_g_error_free0 (e);
		}
		__finally95:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch94_g_regex_error;
			}
			_g_regex_unref0 (hashtags);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	goto __finally94;
	__catch94_g_regex_error:
	{
		GError* e = NULL;
		GError* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp6_ = e;
		_tmp7_ = _tmp6_->message;
		g_warning ("Strings.vala:56: regex error: %s", _tmp7_);
		_g_error_free0 (e);
	}
	__finally94:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_regex_unref0 (hashtags);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp8_ = hashtags;
	_tmp9_ = text;
	_tmp11_ = _tmp10_ = g_regex_split (_tmp8_, _tmp9_, 0);
	_tmp12_ = _tmp11_;
	_tmp12__length1 = _vala_array_length (_tmp10_);
	if (result_length1) {
		*result_length1 = _tmp12__length1;
	}
	result = _tmp12_;
	_g_regex_unref0 (hashtags);
	return result;
}


gchar* birdie_utils_highlight_users (gchar* text) {
	gchar* result = NULL;
	GRegex* users = NULL;
	const gchar* _tmp10_ = NULL;
	gchar* _tmp11_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (text != NULL, NULL);
	{
		GRegex* _tmp0_ = NULL;
		GRegex* _tmp1_ = NULL;
		GRegex* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
		GRegex* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		_tmp1_ = g_regex_new ("\\B([@][[:alpha:]0-9_]+)", 0, 0, &_inner_error_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch96_g_regex_error;
			}
			_g_regex_unref0 (users);
			_g_free0 (text);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp2_ = _tmp0_;
		_tmp0_ = NULL;
		_g_regex_unref0 (users);
		users = _tmp2_;
		_tmp4_ = users;
		_tmp5_ = text;
		_tmp6_ = g_regex_replace (_tmp4_, _tmp5_, (gssize) (-1), 0, "<span underline='none'><a href='birdie://user/\\0'>\\0</a></span>", 0, &_inner_error_);
		_tmp3_ = _tmp6_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_regex_unref0 (_tmp0_);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch96_g_regex_error;
			}
			_g_regex_unref0 (_tmp0_);
			_g_regex_unref0 (users);
			_g_free0 (text);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp7_ = _tmp3_;
		_tmp3_ = NULL;
		_g_free0 (text);
		text = _tmp7_;
		_g_free0 (_tmp3_);
		_g_regex_unref0 (_tmp0_);
	}
	goto __finally96;
	__catch96_g_regex_error:
	{
		GError* e = NULL;
		GError* _tmp8_ = NULL;
		const gchar* _tmp9_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp8_ = e;
		_tmp9_ = _tmp8_->message;
		g_warning ("Strings.vala:70: regex error: %s", _tmp9_);
		_g_error_free0 (e);
	}
	__finally96:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_regex_unref0 (users);
		_g_free0 (text);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp10_ = text;
	_tmp11_ = g_strdup (_tmp10_);
	result = _tmp11_;
	_g_regex_unref0 (users);
	_g_free0 (text);
	return result;
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	{
		GRegex* regex = NULL;
		const gchar* _tmp0_ = NULL;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		GRegex* _tmp3_ = NULL;
		GRegex* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		GRegex* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		_tmp0_ = old;
		_tmp1_ = g_regex_escape_string (_tmp0_, -1);
		_tmp2_ = _tmp1_;
		_tmp3_ = g_regex_new (_tmp2_, 0, 0, &_inner_error_);
		_tmp4_ = _tmp3_;
		_g_free0 (_tmp2_);
		regex = _tmp4_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch97_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp6_ = regex;
		_tmp7_ = replacement;
		_tmp8_ = g_regex_replace_literal (_tmp6_, self, (gssize) (-1), 0, _tmp7_, 0, &_inner_error_);
		_tmp5_ = _tmp8_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch97_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp9_ = _tmp5_;
		_tmp5_ = NULL;
		result = _tmp9_;
		_g_free0 (_tmp5_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally97;
	__catch97_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally97:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


gchar* birdie_utils_highlight_urls (gchar* text) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gchar** text_split = NULL;
	const gchar* _tmp7_ = NULL;
	gchar** _tmp8_ = NULL;
	gchar** _tmp9_ = NULL;
	gint text_split_length1 = 0;
	gint _text_split_size_ = 0;
	gchar** _tmp10_ = NULL;
	gint _tmp10__length1 = 0;
	const gchar* _tmp25_ = NULL;
	gchar* _tmp26_ = NULL;
	g_return_val_if_fail (text != NULL, NULL);
	_tmp0_ = text;
	_tmp1_ = purple_markup_linkify (_tmp0_);
	_tmp2_ = g_strdup (_tmp1_);
	_g_free0 (text);
	text = _tmp2_;
	_tmp3_ = text;
	_tmp4_ = string_replace (_tmp3_, "<A HREF", "<span underline='none'><a href");
	_g_free0 (text);
	text = _tmp4_;
	_tmp5_ = text;
	_tmp6_ = string_replace (_tmp5_, "</A>", "</a></span>");
	_g_free0 (text);
	text = _tmp6_;
	_tmp7_ = text;
	_tmp9_ = _tmp8_ = g_strsplit (_tmp7_, "<a href=\"", 0);
	text_split = _tmp9_;
	text_split_length1 = _vala_array_length (_tmp8_);
	_text_split_size_ = text_split_length1;
	_tmp10_ = text_split;
	_tmp10__length1 = text_split_length1;
	if (_tmp10__length1 > 1) {
		gchar** _tmp11_ = NULL;
		gint _tmp11__length1 = 0;
		_tmp11_ = text_split;
		_tmp11__length1 = text_split_length1;
		{
			gchar** part_collection = NULL;
			gint part_collection_length1 = 0;
			gint _part_collection_size_ = 0;
			gint part_it = 0;
			part_collection = _tmp11_;
			part_collection_length1 = _tmp11__length1;
			for (part_it = 0; part_it < _tmp11__length1; part_it = part_it + 1) {
				gchar* _tmp12_ = NULL;
				gchar* part = NULL;
				_tmp12_ = g_strdup (part_collection[part_it]);
				part = _tmp12_;
				{
					gchar** partofpart = NULL;
					const gchar* _tmp13_ = NULL;
					gchar** _tmp14_ = NULL;
					gchar** _tmp15_ = NULL;
					gint partofpart_length1 = 0;
					gint _partofpart_size_ = 0;
					gchar** _tmp16_ = NULL;
					gint _tmp16__length1 = 0;
					_tmp13_ = part;
					_tmp15_ = _tmp14_ = g_strsplit (_tmp13_, "\">", 0);
					partofpart = _tmp15_;
					partofpart_length1 = _vala_array_length (_tmp14_);
					_partofpart_size_ = partofpart_length1;
					_tmp16_ = partofpart;
					_tmp16__length1 = partofpart_length1;
					if (_tmp16__length1 > 1) {
						const gchar* _tmp17_ = NULL;
						gchar** _tmp18_ = NULL;
						gint _tmp18__length1 = 0;
						const gchar* _tmp19_ = NULL;
						gchar** _tmp20_ = NULL;
						gint _tmp20__length1 = 0;
						const gchar* _tmp21_ = NULL;
						gchar* _tmp22_ = NULL;
						gchar* _tmp23_ = NULL;
						gchar* _tmp24_ = NULL;
						_tmp17_ = text;
						_tmp18_ = partofpart;
						_tmp18__length1 = partofpart_length1;
						_tmp19_ = _tmp18_[0];
						_tmp20_ = partofpart;
						_tmp20__length1 = partofpart_length1;
						_tmp21_ = _tmp20_[0];
						_tmp22_ = string_replace (_tmp21_, "&", "&amp;");
						_tmp23_ = _tmp22_;
						_tmp24_ = string_replace (_tmp17_, _tmp19_, _tmp23_);
						_g_free0 (text);
						text = _tmp24_;
						_g_free0 (_tmp23_);
					}
					partofpart = (_vala_array_free (partofpart, partofpart_length1, (GDestroyNotify) g_free), NULL);
					_g_free0 (part);
				}
			}
		}
	}
	_tmp25_ = text;
	_tmp26_ = g_strdup (_tmp25_);
	result = _tmp26_;
	text_split = (_vala_array_free (text_split, text_split_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (text);
	return result;
}


static gboolean string_contains (const gchar* self, const gchar* needle) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = needle;
	_tmp1_ = strstr ((gchar*) self, (gchar*) _tmp0_);
	result = _tmp1_ != NULL;
	return result;
}


gchar* birdie_utils_remove_html_tags (const gchar* input) {
	gchar* result = NULL;
	gchar* without_html_tags = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	gchar** _tmp4_ = NULL;
	gchar** _tmp5_ = NULL;
	const gchar* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	g_return_val_if_fail (input != NULL, NULL);
	_tmp0_ = input;
	_tmp1_ = purple_markup_strip_html (_tmp0_);
	_tmp2_ = g_strdup (_tmp1_);
	without_html_tags = _tmp2_;
	_tmp3_ = without_html_tags;
	_tmp5_ = _tmp4_ = g_strsplit (_tmp3_, " ", 0);
	{
		gchar** part_collection = NULL;
		gint part_collection_length1 = 0;
		gint _part_collection_size_ = 0;
		gint part_it = 0;
		part_collection = _tmp5_;
		part_collection_length1 = _vala_array_length (_tmp4_);
		for (part_it = 0; part_it < _vala_array_length (_tmp4_); part_it = part_it + 1) {
			gchar* _tmp6_ = NULL;
			gchar* part = NULL;
			_tmp6_ = g_strdup (part_collection[part_it]);
			part = _tmp6_;
			{
				const gchar* _tmp7_ = NULL;
				gboolean _tmp8_ = FALSE;
				_tmp7_ = part;
				_tmp8_ = string_contains (_tmp7_, "(birdie://");
				if (_tmp8_) {
					const gchar* _tmp9_ = NULL;
					const gchar* _tmp10_ = NULL;
					gchar* _tmp11_ = NULL;
					_tmp9_ = without_html_tags;
					_tmp10_ = part;
					_tmp11_ = string_replace (_tmp9_, _tmp10_, "");
					_g_free0 (without_html_tags);
					without_html_tags = _tmp11_;
				}
				_g_free0 (part);
			}
		}
		part_collection = (_vala_array_free (part_collection, part_collection_length1, (GDestroyNotify) g_free), NULL);
	}
	_tmp12_ = without_html_tags;
	_tmp13_ = string_replace (_tmp12_, "  ", " ");
	_g_free0 (without_html_tags);
	without_html_tags = _tmp13_;
	result = without_html_tags;
	return result;
}


gchar* birdie_utils_unescape_html (gchar* text) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	g_return_val_if_fail (text != NULL, NULL);
	_tmp0_ = text;
	_tmp1_ = purple_unescape_html (_tmp0_);
	_tmp2_ = g_strdup (_tmp1_);
	result = _tmp2_;
	_g_free0 (text);
	return result;
}


gchar* birdie_utils_escape_markup (gchar* text) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_val_if_fail (text != NULL, NULL);
	_tmp0_ = text;
	_tmp1_ = g_markup_escape_text (_tmp0_, (gssize) (-1));
	result = _tmp1_;
	_g_free0 (text);
	return result;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



